/*
 *      Pig
 *
 *      (c) Copyright 1990, Yanan Yin
 *
 *      See copyright.h for the terms of the copyright.
 *
 *      @(#)argsx.c       3.0     90/09/14
 *
 */
#include	<stdio.h>

#define DEFAULT_DISPLAY		NULL
#define DEFAULT_GEOMETRY	NULL
#define DEFAULT_FONT		"variable"
#define DEFAULT_TITLE		"test8"

#include "ydefs.h"

extern char pnames[ndpy][120];
extern int  NOSHOW;
extern int  PAIR;
extern int  BELLINT;

getArguments( argc, argv, dpyname )

int	argc;
char	*argv[];
char	dpyname[ndpy][120];

{
	int	argn;
        int     iconicState;
	int	i;
	char	ich1;

	for ( i=0; i<ndpy; i++ )
		{
		dpyname[i][0] = '\0';
		pnames[i][0] = '\0';
		}

	iconicState = 0;

	for ( argn = 0; argn < argc; argn++ )
		{
		if ( strncmp( argv[ argn ], "-h", 2 ) == 0 )
			{
			printHelpMessage();
			exit(1);
			}

		if ( strncmp( argv[ argn ], "-d", 2 ) == 0 )
			{
			ich1 = '1';
			for ( i=0; i<ndpy; i++ )
			   {
			   if ( argv[ argn ][2] == ich1+i )
			      {
			      argn++;
			      if ( argn < argc )
			         {
			         strcpy( dpyname[i], argv[ argn ] );
				 if (dpyname[i][0] != '-')
				    break;
			         }
			      fprintf( stderr,
	 			 "ERROR: the -d%d option should be %s\n",
	 			 i+1, "followed by a display name." );
			      exit(2);
			      }
			   }
			}

		if ( strncmp( argv[ argn ], "-n", 2 ) == 0 )
			{
			ich1 = '1';
			for ( i=0; i<ndpy; i++ )
			   {
			   if ( argv[ argn ][2] == ich1+i )
			      {
			      argn++;
			      if ( argn < argc )
			         {
			         strcpy( pnames[i], argv[ argn ] );
				 if (pnames[i][0] != '-')
				    break;
			         }
			      fprintf( stderr,
	 			 "ERROR: the -n%d option should be %s\n",
	 			 i+1, "followed by a player's name." );
			      exit(3);
			      }
			   }
			}

                if ( strncmp( argv[ argn ], "-iconic", 7 ) == 0 )
                        iconicState = 1;

                if ( strncmp( argv[ argn ], "-noshow", 7 ) == 0 )
                        NOSHOW = 1;

                if ( strncmp( argv[ argn ], "-pair", 5 ) == 0 )
                        PAIR = 1;

                if ( strncmp( argv[ argn ], "-bell", 5 ) == 0 )
			{
			argn++;
			if ( argn < argc )
			   {
                           BELLINT = atoi(argv[ argn ]);
			   if ( BELLINT < 0 || BELLINT > 100 )
			      {
			      fprintf( stderr,
	 			"WARNING: the bell intensity should be between 0 to 100.\n");
			      BELLINT = 40;
			      }
			   }
			else
			   {
			   fprintf( stderr,
	 			"ERROR: the -bell option should be %s\n",
	 			"followed by a number between 0 to 100." );
			   exit(4);
			   }
			}

		}

	for ( i=0; i<ndpy; i++ )
		{
		if ( strlen( dpyname[i] ) < 1 )
			dpyname[i][0] = NULL;
		if ( strlen( pnames[i] ) < 1 )
			sprintf( pnames[i], "PLAYER%d\0", i+1);
		}

	return( iconicState );
}

printHelpMessage()
{
	fprintf( stderr, "The allowable command line options are:\n" );
	fprintf( stderr, "\t-n1 player1's name.\n" );
	fprintf( stderr, "\t-n2 player1's name.\n" );
	fprintf( stderr, "\t-n3 player3's name.\n" );
	fprintf( stderr, "\t-n4 player4's name.\n" );
	fprintf( stderr, "\t-d1 displayname1 \n" );
	fprintf( stderr, "\t\tplayer1's display name.\n" );
	fprintf( stderr, "\t-d2 displayname2 \n" );
	fprintf( stderr, "\t\tplayer2's display name.\n" );
	fprintf( stderr, "\t-d3 displayname3 \n" );
	fprintf( stderr, "\t\tplayer3's display name.\n" );
	fprintf( stderr, "\t-d4 displayname4 \n" );
	fprintf( stderr, "\t\tplayer4's display name.\n" );
	fprintf( stderr, "\t-iconic\n" );
	fprintf( stderr, "\t\tStart with the window in iconic state\n" );
	fprintf( stderr, "\t-noshow\n" );
	fprintf( stderr, "\t\tCards are not to be shown.\n" );
	fprintf( stderr, "\t-pair\n" );
	fprintf( stderr, "\t\tGame is played in pair.\n" );
	fprintf( stderr, "\t-bell loudness\n" );
	fprintf( stderr, "\t\tBell loudness (0 to 100).\n" );
}

