/*
 *      Pig
 *
 *      (c) Copyright 1990, Yanan Yin
 *
 *      See copyright.h for the terms of the copyright.
 *
 *      @(#)colorx.c       3.0     90/09/14
 *
 */
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "ydefs.h"

extern Display *godpy[ndpy];
extern GC      gogc[ndpy];

extern int		theDepth[ndpy];
extern unsigned long	theBlackPixel[ndpy];
extern unsigned long	theWhitePixel[ndpy];
extern Colormap		theColormap[ndpy];
XColor	theRGBColor, theHardwareColor;

nameColor(theName, pigk, optBW)
char	theName[];
int	pigk, optBW;
{
	int	theStatus;

	if ( theDepth[pigk] > 1 )
		{
		theStatus = XLookupColor( godpy[pigk],
				theColormap[pigk],
				theName,
				&theRGBColor,
				&theHardwareColor );
		if ( theStatus != 0 )
			{
			theStatus = XAllocColor( godpy[pigk],
					theColormap[pigk],
					&theHardwareColor );

			if ( theStatus != 0 )
				{
				XSetForeground( godpy[pigk], gogc[pigk],
					theHardwareColor.pixel );
				XFlush( godpy[pigk] );
				}
			}
		}
	else
	    {
	    if ( optBW==0 )
		{
		XSetForeground( godpy[pigk], gogc[pigk], theBlackPixel[pigk]);
		theHardwareColor.pixel = theBlackPixel[pigk];
		}
	    else
		{
		XSetForeground( godpy[pigk], gogc[pigk], theWhitePixel[pigk]);
		theHardwareColor.pixel = theWhitePixel[pigk];
		}
	    XFlush( godpy[pigk] );
	    }
}

gcRGBColor(gck, red, blue, green, pigk, optBW, optFB)
GC  gck;
int red, green, blue;
int     pigk, optBW, optFB;
{
        int     theStatus;

        if ( theDepth[pigk] > 1 )
                {

                theHardwareColor.red   = (  red%256) * 257;
                theHardwareColor.green = (green%256) * 257;
                theHardwareColor.blue  = ( blue%256) * 257;

                theStatus = XAllocColor( godpy[pigk], theColormap[pigk],
                        &theHardwareColor );

                if ( theStatus != 0 )
                        {
			if ( optFB==0 )
                            XSetForeground( godpy[pigk], gck,
                                theHardwareColor.pixel );
			else
                            XSetBackground( godpy[pigk], gck,
                                theHardwareColor.pixel );
                        XFlush( godpy[pigk] );
                        }
/*
                else
                        printf( "  HardwareColor alloc failed. %d %d %d\n",
                                red, green, blue );
*/
                }
        else
            {
            if ( optBW==0 )
		{
		if ( optFB==0 )
                    XSetForeground( godpy[pigk], gck, theBlackPixel[pigk]);
		else
                    XSetBackground( godpy[pigk], gck, theBlackPixel[pigk]);
		theHardwareColor.pixel = theBlackPixel[pigk];
		}
            else
		{
		if ( optFB==0 )
                    XSetForeground( godpy[pigk], gck, theWhitePixel[pigk]);
		else
                    XSetBackground( godpy[pigk], gck, theWhitePixel[pigk]);
		theHardwareColor.pixel = theWhitePixel[pigk];
		}
            XFlush( godpy[pigk] );
            }
}

RGBColor(red, blue, green, pigk, optBW, optFB)
int red, green, blue;
int	pigk, optBW, optFB;
{
	int	theStatus;

	if ( theDepth[pigk] > 1 )
		{

		theHardwareColor.red   = (  red%256) * 257;
		theHardwareColor.green = (green%256) * 257;
		theHardwareColor.blue  = ( blue%256) * 257;

		theStatus = XAllocColor( godpy[pigk], theColormap[pigk],
			&theHardwareColor );

		if ( theStatus != 0 )
			{
			if ( optFB== 0 )
			    XSetForeground( godpy[pigk], gogc[pigk],
				theHardwareColor.pixel );
			else
			    XSetBackground( godpy[pigk], gogc[pigk],
				theHardwareColor.pixel );
			XFlush( godpy[pigk] );
			}
/*
		else
			printf( "  HardwareColor alloc failed. %d %d %d\n",
				red, green, blue );
*/
		}
	else
	    {
	    if ( optBW==0 )
		{
		if ( optFB==0 )
		  XSetForeground( godpy[pigk], gogc[pigk], theBlackPixel[pigk]);
		else
		  XSetBackground( godpy[pigk], gogc[pigk], theBlackPixel[pigk]);
		theHardwareColor.pixel = theBlackPixel[pigk];
		}
	    else
		{
		if ( optFB==0 )
		  XSetForeground( godpy[pigk], gogc[pigk], theWhitePixel[pigk]);
		else
		  XSetForeground( godpy[pigk], gogc[pigk], theWhitePixel[pigk]);
		theHardwareColor.pixel = theWhitePixel[pigk];
		}
	    XFlush( godpy[pigk] );
	    }
}

/*******************************************************************************
*
*                       Define color map look up table
*    Created: Aug. 7, 1990                          Revised: Aug. 7, 1990
********************************************************************************
C out:
C RED(), GREEN(), BLUE(): color look up table
C-----------------------------------------------------------------------------*/

lookuptab( RED, GREEN, BLUE )

double RED[], GREEN[], BLUE[];

{
      int NBG1, NBG2, NBG3, NGR1, NGR2, NGR3, NST;
      int L1, L2, L3, L4;
      float RLLBG, BLLGR;
      NBG1 = 85;
      NBG2 = 5;
      NBG3 = 40;
      NGR1 = 35;
      NGR2 = 5;
      NGR3 = 85;
/*    ____ Red and blue levels in BG band and in GR band */
      RLLBG = .2e0;
      BLLGR = .2e0;
/*    ____ Blue to Green band1: constant blue and increasing green */
      for ( L1 = 1; L1<=NBG1; L1++ )
        {
         BLUE[L1] = 1.e0;
        GREEN[L1] = (L1-1.e0) / (NBG1+NBG2-1.e0);
          RED[L1] = RLLBG;
        }
/*    ____ Blue to Green band2: decreasing blue and increasing green */
      for ( L1 = 1; L1<=NBG2; L1++ )
        {
         BLUE[NBG1+L1] = (NBG2+NBG3-L1) / (NBG2+NBG3-1.e0);
        GREEN[NBG1+L1] = (NBG1+L1-1.e0) / (NBG1+NBG2-1.e0);
          RED[NBG1+L1] = RLLBG;
        }
/*    ____ Blue to Green band3: decreasing blue and constant green */
      NST = NBG1 + NBG2;
      for ( L1 = 1; L1<=NBG3; L1++ )
        {
         BLUE[NST+L1] = (NBG3-L1) / (NBG2+NBG3-1.e0);
        GREEN[NST+L1] = 1.e0;
          RED[NST+L1] = RLLBG;
        }
/*    ____ Green to Red band1: constant green and increasing red */
      NST = NBG1 + NBG2 + NBG3;
      for ( L1 = 1; L1<=NGR1; L1++ )
        {
         BLUE[NST+L1] = BLLGR;
        GREEN[NST+L1] = 1.e0;
          RED[NST+L1] = (L1-1.e0) / (NGR1+NGR2-1.e0);
        }
/*    ____ Green to Red band2: decreasing green and increasing red */
      NST = NBG1 + NBG2 + NBG3 + NGR1;
      for ( L1 = 1; L1<=NGR2; L1++ )
        {
         BLUE[NST+L1] = BLLGR;
        GREEN[NST+L1] = (NGR2+NGR3-L1) / (NGR2+NGR3-1.e0);
          RED[NST+L1] = (NGR1+L1-1.e0) / (NGR1+NGR2-1.e0);
        }
/*    ____ Green to Red band3: decreasing green and constant red */
      NST = NBG1 + NBG2 + NBG3 + NGR1 + NGR2;
      for ( L1 = 1; L1<=NGR3; L1++ )
        {
         BLUE[NST+L1] = BLLGR;
        GREEN[NST+L1] = (NGR3-L1) / (NGR2+NGR3-1.e0);
          RED[NST+L1] = 1.e0;
        }
/*    ____ scale up from 0--1 to 0--255 */
      for ( L1 = 1; L1<=255; L1++ )
        {
          RED[L1] =   RED[L1]*255.e0;
        GREEN[L1] = GREEN[L1]*255.e0;
         BLUE[L1] =  BLUE[L1]*255.e0;
        }
/*    ____ background color */
        RED[0] = 0.0e0;
      GREEN[0] = 0.0e0;
       BLUE[0] = 0.0e0;
}

