/*
 *      Pig
 *
 *      (c) Copyright 1990, Yanan Yin
 *
 *      See copyright.h for the terms of the copyright.
 *
 *      @(#)eventx.c       3.0     90/09/14
 *
 */
#include	<X11/Xlib.h>
#include	<X11/Xutil.h>
#include "defs.h"
#include "ydefs.h"

extern int	PIGROUND;
extern int	PIGGAME;
extern int	PIGCARDS;
extern int	LASTPIG;
extern int	YOURTURN;
extern int	FIRSTSUIT;
extern int	FIRSTBID;
extern int	NOSHOW;

extern char	pnames[ndpy][120];
extern int	FOURCARDS[4][2];
extern int	shcardowner[4];
extern int	shcardrecord[4];
extern int	firstshowsuit[4];

extern Display *godpy[ndpy];
extern Window  gowind[ndpy];
extern Window  windtalk[ndpy];
extern Window  windscore[ndpy];
extern Window  windtext[ndpy];
extern GC	gctalk[ndpy];
extern GC	gcscore[ndpy];
extern GC	gctext[ndpy];

extern int     flagscore[ndpy];
extern int     flagtalk[ndpy];

extern Window	windPass[ndpy];
extern GC	gcPass[ndpy];
extern int textoggle[ndpy], textcount[ndpy];

extern int wline, hline, wchar, textyoff, wbuff;
extern int wframe, hframe, wsubframe, hsubframe;

#define EV_MASK (ButtonPressMask|\
		ButtonReleaseMask|\
		ExposureMask|\
		EnterWindowMask|\
		LeaveWindowMask|\
		KeyPressMask|\
		StructureNotifyMask)

eventLoop(dpyk, windk, gck, xorgck, pigk)
Display	*dpyk;
Window	windk;
GC	gck, xorgck;
int	pigk;

{
    XEvent theEvent;
    int i;

    if ( XCheckMaskEvent( dpyk, EV_MASK, &theEvent ) == False )
	return(1);

    switch( theEvent.type )
	{
	case ConfigureNotify:
	case MapNotify:
	    break;

	case Expose:
	    while (XCheckTypedEvent(dpyk, Expose, &theEvent));
	    redraw_table(&theEvent, dpyk, windk, gck, pigk);
	    draw_talkframe(pigk);
	    draw_speaker(dpyk, windk, gck, pigk);
	    if ( flagtalk[pigk]==1 )
		{
		draw_textframe(pigk);
		reprint_text(pigk);
		}
	    if ( PIGCARDS>0 )
		{
		redraw_showcard(&theEvent, dpyk, windk, gck, pigk);
		draw_scoreframe(pigk);
		}
	    if ( PIGCARDS==14 && pigk==YOURTURN )
		{
		showcard_mes(pigk, 800, 450);
		gcRGBColor(gcPass[pigk], 255, 255, 50, pigk, 0, 0);
		XDrawString( dpyk, windPass[pigk], gcPass[pigk], 70, 15,
		    "PASS", strlen("PASS"));
		}
		break;

	case EnterNotify:
	    if ( theEvent.xany.window==windPass[pigk] )
		{
	        if ( PIGCARDS==14 ) bdhighlit(windPass[pigk], pigk, 0);
		}
	    else if ( theEvent.xany.window==windtalk[pigk] )
	        bdhighlit(windtalk[pigk], pigk, 0);
	    else if ( theEvent.xany.window==windscore[pigk] )
		{
	        if ( PIGCARDS>=0 ) bdhighlit(windscore[pigk], pigk, 0);
		}
	    else if ( theEvent.xany.window==windtext[pigk] )
	        bdhighlit(windtext[pigk], pigk, 0);
	    break;

	case LeaveNotify:
	    if ( theEvent.xany.window==windPass[pigk] )
		{
	        if ( PIGCARDS==14 ) bdhighlit(windPass[pigk], pigk, 1);
		}
	    else if ( theEvent.xany.window==windtalk[pigk] )
	        bdhighlit(windtalk[pigk], pigk, 1);
	    else if ( theEvent.xany.window==windscore[pigk] )
		{
	        if ( PIGCARDS>=0 ) bdhighlit(windscore[pigk], pigk, 1);
		}
	    else if ( theEvent.xany.window==windtext[pigk] )
	        bdhighlit(windtext[pigk], pigk, 1);
	    break;

	case ButtonPress:
	    if ( theEvent.xany.window==windk ||
		 theEvent.xany.window==windPass[pigk] ) 
		{
		processButtEv(&theEvent, dpyk, windk, pigk);
		break;
		}
	    else if ( theEvent.xany.window==windtalk[pigk] )
		{
		if ( flagtalk[pigk]==0 )
		    {
		    bghighlit(windtalk[pigk], gctalk[pigk], pigk,
			5, 14, "    TALK", 0);
		    sleep(1);
		    XMapWindow(dpyk, windtext[pigk]);
		    draw_textframe(pigk);
		    reprint_text(pigk);
		    bghighlit(windtalk[pigk], gctalk[pigk], pigk,
			5, 14, "QUIT TALKING", 1);
		    flagtalk[pigk] = 1;
		    }
		else
		    {
		    bghighlit(windtalk[pigk], gctalk[pigk], pigk,
			5, 14, "QUIT TALKING", 0);
		    sleep(1);
		    XUnmapWindow(dpyk, windtext[pigk]);
		    XClearArea(dpyk, windk,
			 0, 240, wframe+20, hframe+20, False);
		    bghighlit(windtalk[pigk], gctalk[pigk], pigk,
			5, 14, "    TALK", 1);
		    flagtalk[pigk] = 0;
		    }
		}
	    else if ( theEvent.xany.window==windscore[pigk] )
		{
		bghighlit(windscore[pigk], gcscore[pigk], pigk,
		    5, 14, "SCORE", 0);
		draw_score(1, pigk);
		}
	    break;

	case ButtonRelease:
	    if ( theEvent.xany.window==windscore[pigk] ) 
		{
		bghighlit(windscore[pigk], gcscore[pigk], pigk,
		    5, 14, "SCORE", 1);
		XClearArea( dpyk, windk, 60, 90, 290, 105, False);
		restore_message(pigk);
		}
	    break;

	case KeyPress:
	    processKeyPress(&theEvent, pigk);
	    break;
	}
	return(1);
}

processButtEv(buttev, dpyk, windk, pigk)
XButtonEvent *buttev;
Display *dpyk;
Window windk;
int pigk;
{
    char tmp[120];
    int pickcard, i, owner;
    static nturn;

    if ( PIGROUND == 0 )
	{
	start_screen(-1);
	return(1);
	}
    if ( PIGCARDS < 0 )
	{
	if ( PIGROUND>1 && pigk!=LASTPIG ) return(1);

	if ( buttev->x >= SRNW/2-106 &&
	     buttev->x <= SRNW/2-108+CARD_WIDTH*2 &&
	     buttev->y >= SRNH/2+1  &&
	     buttev->y <= SRNH/2-1+CARD_HEIGHT*2 )
	    {
	    for ( i=0; i<ndpy; i++ ) XMapWindow(godpy[i], windscore[i]);
	    if ( NOSHOW==0 )
		PIGCARDS = 14;
	    else
		PIGCARDS = 13;
	    pick_cards(pigk);
	    if ( LASTPIG>3 ) LASTPIG = firsturn();
	    FIRSTBID = LASTPIG;
	    for ( i=0; i<4; i++ )
		{
		draw_scoreframe(i);
		draw_talkframe(i);
	    	if ( flagtalk[i]==1 ) draw_textframe(i);
		}

	    nturn = 0;
	    YOURTURN = LASTPIG;
	    if ( NOSHOW==0 )
		{
		sprintf(tmp, "Waiting for %s to show the cards...\0",
		    pnames[YOURTURN]);
		draw_multimessage( "Your turn to show the cards...\0",
			tmp, YOURTURN, -1);
		show_cards(YOURTURN);
		}
	    else
		{
		sprintf(tmp,"Waiting for %s...\0", pnames[YOURTURN]);
		draw_multimessage("Your turn now...\0", tmp, YOURTURN, -1);
		}
	    }
	}
    else if (PIGCARDS==14)
	{
	if ( pigk!=YOURTURN ) return(1);
	if ( buttev->window==windPass[pigk] )
	    {
	    bghighlit(windPass[pigk], gcPass[pigk], YOURTURN, 70, 15, "PASS",0);
	    sleep(1);
	    bghighlit(windPass[pigk], gcPass[pigk], YOURTURN, 70, 15, "PASS",1);
	    XUnmapWindow( dpyk, windPass[pigk] );
	    XClearArea(dpyk, windk, 768, 418, 264, 214, False);
	    for ( i=0; i<4; i++ )
		if ( i!=YOURTURN ) draw_showcard(YOURTURN, i);

	    YOURTURN = (YOURTURN+1)%4;
	    nturn ++;

	    if ( shcardowner[0]<4 && shcardowner[1]<4 &&
		 shcardowner[2]<4 && shcardowner[3]<4 )
		{
		nturn = 4;
		YOURTURN = FIRSTBID;
		}

	    if( nturn<4 )
		{
		sprintf(tmp, "Waiting for %s to show the cards...\0",
		    pnames[YOURTURN]);
		draw_multimessage( "Your turn to show the cards...\0",
		    tmp, YOURTURN, -1);
		show_cards(YOURTURN);
		}
	    }
	else
	    pick_showcard(buttev->x, buttev->y, YOURTURN);

	if ( nturn == 4 )
	    {
	    nturn = 0;
	    PIGCARDS = 13;
	    for ( i=0; i<4; i++ )
		shcardrecord[i] = shcardowner[i];
	    sprintf(tmp,"Waiting for %s...\0", pnames[YOURTURN]);
	    draw_multimessage("Your turn now...\0", tmp, YOURTURN, -1);
	    }
	}
    else if (PIGCARDS>0 &&  PIGCARDS<=13)
	{
	if ( pigk != YOURTURN ) return(1);

	pickcard = bid_cards(buttev->x, buttev->y, pigk);

	if ( pickcard < 52 )
	    {
	    FOURCARDS[nturn][0] = pigk;
	    FOURCARDS[nturn][1] = pickcard;
	    if ( YOURTURN==FIRSTBID ) FIRSTSUIT = pickcard/13; 
	    YOURTURN = (YOURTURN+1)%4;
	    nturn ++;
	    if ( nturn == 4 ) /*claim demerit*/
		{
		claim_demerit(FOURCARDS);
		PIGCARDS --;
		firstshowsuit[FIRSTSUIT] ++;
		nturn = 0;
		}
	    if ( PIGCARDS>0 )
		{
		sprintf(tmp,"Waiting for %s...\0", pnames[YOURTURN]);
		draw_multimessage("Your turn now...\0", tmp, YOURTURN, -1);
		}
	    else
		{
		for ( i=0; i<ndpy; i++ )
		    {
		    XUnmapWindow(godpy[i], windscore[i]);
		    XClearArea(godpy[i], gowind[i], 105, 198, 51, 31, False);
		    }
		count_score();
		start_screen(-1);
		}
	    }
	}
    return(1);
}

