/*
 *      Pig
 *
 *      (c) Copyright 1990, Yanan Yin
 *
 *      See copyright.h for the terms of the copyright.
 *
 *      @(#)keyx.c       3.0     90/09/14
 *
 */
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <X11/keysymdef.h>
#include "ydefs.h"

extern Display *godpy[ndpy];
extern Window  gowind[ndpy];
extern GC      gogc[ndpy];
extern Window  windtext[ndpy];
extern GC       gctext[ndpy];

extern int textoggle[ndpy], textcount[ndpy];
extern char textbuff[ndpy][150];
extern int flagtalk[ndpy];

extern int  wline, hline, wchar, textyoff, wbuff;
extern int wframe, hframe, wsubframe, hsubframe;

processKeyPress(theEvent, pigk)
XKeyEvent *theEvent;
{
    int		length;
    int		theKeyBufferMaxLen = 64;
    char	theKeyBuffer[ 65 ];
    KeySym	theKeySym;
    XComposeStatus theComposeStatus;

    length = XLookupString( theEvent, theKeyBuffer, theKeyBufferMaxLen,
			&theKeySym, &theComposeStatus );

    gcRGBColor(gctext[pigk], 0, 0, 0, pigk, 0, 0);
    if ( (theKeySym>=' ') && (theKeySym<='~') && (length>0) )
	{
	print_ascii(theKeyBuffer, pigk, 20, 30);
	draw_speaking(pigk);
	}
    else
	{
	print_special(theKeySym, pigk, 20, 30);
	draw_speaking(pigk);
	}
    return( 1 );
}

print_ascii(keyb, pigk, xs, ys)
char	keyb[];
int     pigk, xs, ys;
{
    int length, i, owner, hcons;

    hcons = (hsubframe+25);
    for ( i=0; i<4; i++ )
	{
	owner = (pigk+i)%4;
	if ( flagtalk[owner]==1 )
	    {
	    XClearArea(godpy[owner], windtext[owner],
	        xs+3+textcount[pigk]*wchar,
	        ((4-i)%4)*hcons+ys+textyoff+textoggle[pigk]*hline,
	        wchar, hline, False);
	    XDrawString(godpy[owner], windtext[owner], gctext[owner],
	        xs+2+textcount[pigk]*wchar,
	        ((4-i)%4)*hcons+ys+textyoff+10+textoggle[pigk]*hline,
	        keyb, 1);
	    }
	}
    length = textcount[pigk] + wbuff * textoggle[pigk];
    textbuff[pigk][length] = keyb[0];
    textbuff[pigk][length+1] = '\0';
    textcount[pigk]++;
    if ( textcount[pigk]>=wline )
	{
	textcount[pigk] = 0;
	textoggle[pigk] = (textoggle[pigk]+1)%3;
	textbuff[pigk][wbuff*textoggle[pigk]] = '\0';
	for ( i=0; i<4; i++ )
	    {
	    owner = (pigk+i)%4;
	    if ( flagtalk[owner]==1 )
	  	{
	        XClearArea(godpy[owner], windtext[owner],
		    xs+2,
		    ((4-i)%4)*hcons+ys+textyoff+textoggle[pigk]*hline,
		    (wline+1)*wchar, hline, False);
		}
	    }
	}
    XDrawString(godpy[pigk], windtext[pigk], gctext[pigk],
	xs+2+textcount[pigk]*wchar,
	ys+textyoff+10+textoggle[pigk]*hline, "_", 1);
}

print_special(theKeySym, pigk, xs, ys)
KeySym	theKeySym;
int     pigk, xs, ys;
{
    int length, i, owner, hcons;

    hcons = (hsubframe+25);
    switch( theKeySym )
	{
	case XK_BackSpace:
	case XK_Delete:
	    if ( textcount[pigk]>0 )
	        {
	        textcount[pigk] -- ;
	        length = textcount[pigk] + wbuff * textoggle[pigk];
	        textbuff[pigk][length+1] = '\0';
		for ( i=0; i<4; i++ )
		    {
		    owner = (pigk+i)%4;
		    if ( flagtalk[owner]==1 )
		      {
		      XClearArea(godpy[owner], windtext[owner],
			xs+3+textcount[pigk]*wchar,
			((4-i)%4)*hcons+ys+textyoff+textoggle[pigk]*hline,
			2*wchar+4, hline, False);
			}
		    }
		XDrawString( godpy[pigk], windtext[pigk], gctext[pigk],
		    xs+2+textcount[pigk]*wchar,
		    ys+textyoff+10+textoggle[pigk]*hline, "_", 1);
		}
	    break;
	case XK_Return:
	    for ( i=0; i<4; i++ )
		{
		owner = (pigk+i)%4;
		if ( flagtalk[owner]==1 )
		    {
		    XClearArea(godpy[owner], windtext[owner],
		        xs+3+textcount[pigk]*wchar,
		        ((4-i)%4)*hcons+ys+textyoff+textoggle[pigk]*hline,
			wchar, hline, False);
		    }
		}
	    textcount[pigk] = 0;
	    textoggle[pigk] = (textoggle[pigk]+1)%3;
	    textbuff[pigk][wbuff*textoggle[pigk]] = '\0';
	    for ( i=0; i<4; i++ )
		{
		owner = (pigk+i)%4;
		if ( flagtalk[owner]==1 )
		    {
	            XClearArea(godpy[owner], windtext[owner], xs+2,
			((4-i)%4)*hcons+ys+textyoff+textoggle[pigk]*hline,
		        (wline+1)*wchar, hline, False);
		    }
		}
	    XDrawString( godpy[pigk], windtext[pigk], gctext[pigk],
		xs+2+textcount[pigk]*wchar,
		ys+textyoff+10+textoggle[pigk]*hline, "_", 1);
	    break;
	}
}

reprint_text(pigk)
int pigk;
{
    int i, owner;

    gcRGBColor(gctext[pigk], 0, 0, 0, pigk, 0, 0);
    for ( i=0; i<4; i++ )
	{
	owner = (pigk+i)%4;
	reprint_textbuff(godpy[pigk], windtext[pigk], gctext[pigk], owner,
	    20, 30+i*(hsubframe+25));
	}
    XDrawString( godpy[pigk], windtext[pigk], gctext[pigk],
	20+2+textcount[pigk]*wchar,
	30+textyoff+10+textoggle[pigk]*hline, "_", 1);
	
}

reprint_textbuff(dpyt, windt, gct, pigk, xs, ys)
Display *dpyt;
Window   windt;
GC       gct;
int pigk, xs, ys;
{
    int i, j;

    for ( i=0; i<3; i++ )
	for ( j=0; j<wline; j++ )
	    {
	    if ( textbuff[pigk][wbuff*i+j]=='\0' ) break;
	    XDrawString(dpyt, windt, gct,
		xs+2+j*wchar, ys+textyoff+10+i*hline,
		&textbuff[pigk][wbuff*i+j], 1);
	    }
}

