/*
 *      Pig
 *
 *      (c) Copyright 1990, Yanan Yin
 *
 *      See copyright.h for the terms of the copyright.
 *
 *      @(#)pig.c       3.0     90/09/14
 *
 */
#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>

#include "defs.h"
#include "ydefs.h"
#include "bitm/goahead.bm"
#include "bitm/stop.bm"
#include "bitm/speaker.bm"
#include "bitm/speaking.bm"

int	PIGGAME;
int	PIGROUND;
int	PIGCARDS;
int	LASTPIG;
int	YOURTURN;
int	FIRSTSUIT;
int	FIRSTBID;
int	NOSHOW;
int	PAIR;
int	BELLINT;

int	CARDSEQ[52];
int	PLAYERCARD[4][13];
int	TOTSCORES[4];
char	pnames[4][120];
int     FOURCARDS[4][2];

Display		*godpy[ndpy];
int     	gosrn[ndpy];
GC		gogc[ndpy];
GC		goxorgc[ndpy];
Window		gowind[ndpy];
XFontStruct	*fontStruct[ndpy];
XFontStruct	*textStruct[ndpy];
Pixmap  goaheadPixmap[ndpy];
Pixmap  stopPixmap[ndpy];
Pixmap  speakerPixmap[ndpy];
Pixmap  speakingPixmap[ndpy];
Window	windtalk[ndpy];
Window	windscore[ndpy];
Window	windtext[ndpy];

GC	gctalk[ndpy];
GC	gcscore[ndpy];
GC	gctext[ndpy];

Window  windPass[ndpy];
GC      gcPass[ndpy];
int flagscore[ndpy];
int flagtalk[ndpy];
int textoggle[ndpy], textcount[ndpy];
char textbuff[ndpy][160];
int wline, hline, wchar, textyoff, wbuff;
int wframe, hframe, wsubframe, hsubframe;

extern Display          *dpy;
extern Window           table;
extern Colormap         theColormap[ndpy];

static double ared[256], agreen[256], ablue[256];

main( argc, argv )

int	argc;
char	*argv[];
{
    Window 	openWindow();
    XFontStruct	*initFont();
    int		iconicState;
    int		x, y, width, height;
    char	dpyname[ndpy][ 120 ];
    int		eventLoop(), i, j;
    unsigned long seleMask;
    int		done, eventhere;
    int		connum;
    int		mask;			/* file-descriptor mask */
    int		readfds;		/* read-file-descriptor mask for select */
    int		wrfds;			/* write-file-descriptor mask (unused) */
    int		exfds;			/* exception-file-descriptor mask (unused) */
    struct timeval timeout;		/* timeout for select call */
    int		nfds;			/* number of file descriptors for select */
    int		nfound;			/* number of found file descriptors */

    NOSHOW = 0;
    PAIR = 0;
    BELLINT = 40;
    iconicState = getArguments( argc, argv, dpyname );
    initX( dpyname );
    lookuptab( ared, agreen, ablue );

    wline = 49;
    hline = 17;
    wchar = 8;
    textyoff = 6;
    wbuff = wline+1;
    wsubframe = 18+wline*wchar;
    hsubframe = 16+hline*3;
    wframe = wsubframe+25;
    hframe = 10+4*(hsubframe+25);

    for ( i=0; i<ndpy; i++ )
	{
	flagscore[i] = 0;
	textoggle[i] = 0;
	textcount[i] = 0;
	flagtalk[i] = 0;
	for ( j=0; j<3; j++ ) textbuff[i][wbuff*i] = '\0';

	gowind[i] = openWindow(godpy[i], gosrn[i], 0, 0, 1130, 860,
	    iconicState, &gogc[i], i );

        XSelectInput(godpy[i], gowind[i],
                ButtonPressMask|ExposureMask|StructureNotifyMask);
	xorSetUp(godpy[i], gowind[i], &goxorgc[i], i);

	seleMask = ButtonPressMask|EnterWindowMask|LeaveWindowMask;
	windtalk[i] = subWindow(godpy[i], gowind[i], 1, 200, 80, 20,
	    &gctalk[i], i, seleMask, 0);

	seleMask = ButtonPressMask|ButtonReleaseMask|
		   EnterWindowMask|LeaveWindowMask;
	windscore[i] = subWindow(godpy[i], gowind[i], 107, 200, 40, 20,
	    &gcscore[i], i, seleMask, 1);

	seleMask = KeyPressMask|EnterWindowMask|LeaveWindowMask;
	windtext[i] = subWindow(godpy[i], gowind[i], 1, 241,
	    wframe+4, hframe+4, &gctext[i], i, seleMask, 1);

	if ( NOSHOW == 0 )
	    {
	    seleMask = ButtonPressMask|EnterWindowMask|LeaveWindowMask;
	    windPass[i] = subWindow(godpy[i], gowind[i], 795, 580,
		200, 30, &gcPass[i], i, seleMask, 1);
	    initFont( godpy[i], gcPass[i], "6x13" );
	    }

	fontStruct[i] = initFont( godpy[i], gogc[i], "6x13" );
	initFont( godpy[i], gctalk[i], "6x13" );
	initFont( godpy[i], gcscore[i], "6x13" );
	textStruct[i] = initFont( godpy[i], gctext[i], "9x15" );

	goaheadPixmap[i] = XCreateBitmapFromData( godpy[i], gowind[i],
	    goahead_bits, goahead_width, goahead_height );
	stopPixmap[i] = XCreateBitmapFromData( godpy[i], gowind[i],
	    stop_bits, stop_width, stop_height );

	speakerPixmap[i] = XCreateBitmapFromData( godpy[i], gowind[i],
	    speaker_bits, speaker_width, speaker_height);
	speakingPixmap[i] = XCreateBitmapFromData( godpy[i], gowind[i],
	    speaking_bits, speaking_width, speaking_height);
	}
    init_showcard();

    LASTPIG = 1000;
    PIGGAME = 1;
    PIGROUND = 0;
    start_screen(-1);
    for ( i=0; i<4; i++ )
	{
	draw_talkframe(i);
	draw_speaker(godpy[i], gowind[i], gogc[i], i);
	}

    /* initialize variables for the select call (referring to */
    /* John Oliver's Introduction to X windoe System, pp404-408) */

    timeout.tv_sec = 60;	/* 60 sec.s select timeout */
    timeout.tv_usec = 0;
    mask = 0;
    nfds = 0;
    for ( i=0; i<ndpy; i++ )
	{
	connum = ConnectionNumber(godpy[i]);
	mask |= (1<<connum);
	nfds = (nfds < connum) ? connum : nfds;
	}
    /* From select manual page: nfds is the number of bits to be checked in */
    /* each bit mask that represent a file descriptor; the descriptors from */
    /* 0 through nfds-1 in the descriptor sets are examined.                */
    nfds++;

    done = 0;
    while( !done )
	{ 

	eventhere = 1;
	while (eventhere)
	    {
	    eventhere = 0;
	    for ( j=0; j<ndpy; j++ )
		{
		if (XEventsQueued(godpy[j], QueuedAfterReading) > 0)
		    eventhere = eventLoop(godpy[j], gowind[j], gogc[j],
				goxorgc[j], j);
		else
		    XFlush(godpy[j]);
		}
	    }

	/* if no event queued on all the display connections, do select */
	if (!eventhere)
	    {
	    readfds = mask;	/* initialize read fd mask */
	    wrfds = exfds = 0;
#ifdef __hpux
	    nfound = select(nfds,(fd_set *) &readfds,(fd_set *)  &wrfds,(fd_set *)  &exfds, &timeout);
#else
	    nfound = select(nfds, &readfds, &wrfds, &exfds, &timeout);
#endif
	    }
	}

    for ( i=0; i<ndpy; i++ )
	{
	XFreeFont( godpy[i], fontStruct[i] );
	XFreeFont( godpy[i], textStruct[i] );
	XDestroyWindow( godpy[i], gowind[i] );
	XFlush( godpy[i] );
	quitX( godpy[i] );
	}
}

