/*
 *      Pig
 *
 *      (c) Copyright 1990, Yanan Yin
 *
 *      See copyright.h for the terms of the copyright.
 *
 *      @(#)pigcard.c       3.0     90/09/14
 *
 */
#include "defs.h"
#include "ydefs.h"

extern int      PIGROUND;
extern int      PIGGAME;
extern int      PIGCARDS;
extern int      LASTPIG;
extern int      YOURTURN;
extern int      FIRSTSUIT;
extern int      FIRSTBID;
extern int      PAIR;
extern int      BELLINT;

extern int     CARDSEQ[52];
extern int     PLAYERCARD[4][13];
extern int     TOTSCORES[4];
extern char	pnames[4][120];
extern int      FOURCARDS[4][2];

extern Display *godpy[ndpy];
extern GC      gogc[ndpy];
extern GC      goxorgc[ndpy];
extern int     gosrn[ndpy];
extern Window  gowind[ndpy];
extern Pixmap  goaheadPixmap[ndpy];
extern Pixmap  stopPixmap[ndpy];
extern Pixmap  speakerPixmap[ndpy];
extern Pixmap  speakingPixmap[ndpy];
extern Window  windtalk[ndpy];
extern Window  windscore[ndpy];
extern Window  windtext[ndpy];
extern GC       gctalk[ndpy];
extern GC       gcscore[ndpy];
extern GC       gctext[ndpy];
extern int     flagscore[ndpy];
extern int     flagtalk[ndpy];
extern Window windPass[ndpy];
extern GC	gcPass[ndpy];

extern Display          *dpy;
extern Window           table;

extern int              theDepth[ndpy];
extern unsigned long    theBlackPixel[ndpy];
extern unsigned long    theWhitePixel[ndpy];

extern XColor  theRGBColor, theHardwareColor;

extern int wline, hline, wchar, textyoff, wbuff;
extern int wframe, hframe, wsubframe, hsubframe;

int demerit[4][17] = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	Qpig,13,14,16,18,20,25,0,0,0,0,0,0,0,0,0,7,
	15,17,Jsheep,0,0,0,0,0,0,0,0,0,0,0,0,0,3,
	19,21,22,23,24,Trans,0,0,0,0,0,0,0,0,0,0,6};

static int CARDX[14] =
{ 0, CARD_WIDTH,  2*CARD_WIDTH,  3*CARD_WIDTH, 4*CARD_WIDTH,  5*CARD_WIDTH,
   6*CARD_WIDTH,  7*CARD_WIDTH,  8*CARD_WIDTH, 9*CARD_WIDTH, 10*CARD_WIDTH,
  11*CARD_WIDTH, 12*CARD_WIDTH, 13*CARD_WIDTH };

static int cardscore[13] = { 0, 0, 0, -10, -10, -10, -10, -10, -10,
			   -20, -30, -40, -50 };

static char SUITNAME[4][120] = {"Spade\0", "Heart\0", "Club\0", "Diamond\0"};

static int score[4];

Pixmap shcard[4][4];
static int shcardata[4]={10,25,34,48};
int        shcardowner[4];
int        shcardrecord[4];
int        firstshowsuit[4];

start_screen( redraw_flag ) /* paint the start screen */
int redraw_flag; /* <0: redraw all; 0< and <4: redraw screen redraw_flag */
{
	int i, j;
	char tmp[120];

	if ( redraw_flag<0 || redraw_flag>3 )
		{
		PIGCARDS = -1;
		PIGROUND ++;
		for ( j=0; j<ndpy; j++ ) /* reset demerit array */
		   demerit[j][16] = 0;
		for ( j=0; j<4; j++ ) /* reset showcard and first show suit */
		    {
		    shcardowner[j] = 4;
		    firstshowsuit[j] = 0;
		    }
		}

	for ( j=0; j<ndpy; j++ ) /* paint each screen */
	   {
	   if ( redraw_flag>=0 && redraw_flag<4 && j!=redraw_flag )
		continue;
	   /* draw the pile */
	   XClearWindow( godpy[j], gowind[j] );
	   for ( i = 0; i<52; i+=4 ) 
		{
		RGBColor(10, 10, 10, j, 0, 0);

        	XDrawRectangle( godpy[j], gowind[j], gogc[j],
			 (int)(SRNW/2-80-i*.5), (int)(SRNH/2-25+i*.5),
			 CARD_WIDTH*2, CARD_HEIGHT*2 );

		RGBColor(255, 255, 255, j, 1, 0);

	        XFillRectangle( godpy[j], gowind[j], gogc[j],
			 (int)(SRNW/2-80-i*.5+1), (int)(SRNH/2-25+i*.5+1),
			 CARD_WIDTH*2-2, CARD_HEIGHT*2-2 );
		if ( i+4 >= 52 )
			{
			RGBColor(255, 0, 0, j, 1, 0);

		        XFillRectangle( godpy[j], gowind[j], gogc[j],
			   (int)(SRNW/2-80-i*.5+1), (int)(SRNH/2-25+i*.5+1),
			   CARD_WIDTH*2-1, CARD_HEIGHT*2-1 );
			}
		}

	    RGBColor(0, 255, 0, j, 0, 0);
	    if ( LASTPIG>3 )
		{
		if ( PIGGAME==1 )
		    {
		    /* game tile and message */
		    XDrawImageString( godpy[j], gowind[j], gogc[j],
		        SRNW/2-110, SRNH/2-275,
                    "WELCOME TO PIG-DRIVING", strlen("WELCOME TO PIG-DRIVING"));
		    XDrawImageString( godpy[j], gowind[j], gogc[j],
		        SRNW/2-70, SRNH/2-225,
		        "Version 3.0", strlen( "Version 3.0" ) );
		    }
		else
		    {
		    XDrawImageString( godpy[j], gowind[j], gogc[j],
		        SRNW/2-90, SRNH/2-275, "PIG-DRIVING in process...",
		        strlen("PIG-DRIVING in process..."));
		    sprintf(tmp,"GAME = %d   ROUND = %d\0", PIGGAME, PIGROUND );
		    XDrawImageString( godpy[j], gowind[j], gogc[j],
		        SRNW/2-80, SRNH/2-225, tmp, strlen(tmp));
		    }

	        RGBColor(255, 0, 255, j, 0, 0);
		XDrawString( godpy[j], gowind[j], gogc[j],
		    SRNW/2-70, SRNH/2+60,
                    "Game starts", strlen( "Game starts" ) );
		XDrawString( godpy[j], gowind[j], gogc[j],
		    SRNW/2-60, SRNH/2+90,
                    "if anyone", strlen( "if anyone" ) );
		XDrawString( godpy[j], gowind[j], gogc[j],
		    SRNW/2-70, SRNH/2+120,
                    "presses button", strlen( "presses button" ) );
		XDrawString( godpy[j], gowind[j], gogc[j],
		    SRNW/2-50, SRNH/2+150,
                    "here...", strlen( "here..." ) );
		}
	    else
		{
		/* GAME, ROUND and message */
		XDrawImageString( godpy[j], gowind[j], gogc[j],
		    SRNW/2-90, SRNH/2-275, "PIG-DRIVING in process...",
		    strlen("PIG-DRIVING in process..."));
		sprintf(tmp, "GAME = %d   ROUND = %d\0", PIGGAME, PIGROUND );
		XDrawImageString( godpy[j], gowind[j], gogc[j],
		    SRNW/2-80, SRNH/2-225, tmp, strlen(tmp));

	        RGBColor(255, 0, 255, j, 0, 0);
		if ( j==LASTPIG )
		    {
		    XDrawString( godpy[j], gowind[j], gogc[j],
		        SRNW/2-60, SRNH/2+60,
                        "Would you", strlen( "Would you" ) );
		    XDrawString( godpy[j], gowind[j], gogc[j],
		        SRNW/2-80, SRNH/2+90,
                        "please serve by", strlen( "please serve by" ) );
		    XDrawString( godpy[j], gowind[j], gogc[j],
		        SRNW/2-80, SRNH/2+120,
                        "pressing a button", strlen( "pressing a button" ) );
		    XDrawString( godpy[j], gowind[j], gogc[j],
		        SRNW/2-50, SRNH/2+150,
                        "here...", strlen( "here..." ) );
		    }
		else
		    {
		    XDrawString( godpy[j], gowind[j], gogc[j],
		        SRNW/2-65, SRNH/2+90,
			pnames[LASTPIG], strlen(pnames[LASTPIG]) );
		    XDrawString( godpy[j], gowind[j], gogc[j],
		        SRNW/2-70, SRNH/2+120,
                        "serves this", strlen( "serves this" ) );
		    XDrawString( godpy[j], gowind[j], gogc[j],
		        SRNW/2-55, SRNH/2+150,
                        "time...", strlen( "time..." ) );
		    }
		XFlush( godpy[j] );
		}
	   }

	if ( PIGROUND == 1 )
	    {
	    draw_score(2, redraw_flag);
	    if ( redraw_flag<0 || redraw_flag>3 )
            	for ( i=0; i<ndpy; i++ ) TOTSCORES[i] = 0;
	    }
	else
	    draw_score(1, redraw_flag);

}

pick_cards(player)
int player;
{
	int tmp[52], i, j, owner, pickcard, rank, suit;

	/* shaffle cards for ten times */
	if ( PIGGAME==1 && PIGROUND==1 )
	    {
	    for ( i=0; i<26; i++ )
		{
		tmp[i] = 2*i;
		tmp[26+i] = 2*i+1;
		}
	    }
	else
		for ( i=0; i<52; i++ ) tmp[i] = CARDSEQ[i];

	shaffle_cards( tmp, CARDSEQ );

	/* pick cards with the player first*/
	for ( i=0; i<13; i++ )
		for ( j=0; j<4; j++ )
			PLAYERCARD[(player+j)%4][i] = CARDSEQ[i*4+j];

	/* reorder cards and draw cards for each player */
	for ( i=0; i<ndpy; i++ )
		{
		reorder_cards( PLAYERCARD[i], 13 );
		draw_cards( godpy[i], gowind[i], gogc[i], PLAYERCARD[i], i );
		}
}

bid_cards(x, y, owner)
int x, y, owner;
{
	int pickcard, cardret, rank, suit, i, j, nbidsuit;
	char tmp[120];

	if ( x>=0 && x<=PIGCARDS*CARD_WIDTH &&
	     y>=SRNH-CARD_HEIGHT && y<=SRNH )
		{
		for ( i=0; i<PIGCARDS; i++ )
			if ( x>=CARDX[i] && x<CARDX[i+1] )
				{
				pickcard = i;
        			cardret = PLAYERCARD[owner][pickcard];
				break;
				}
		}
	else
		{
		draw_message( owner, "Please pick a card...\0");
		return(54);
		}

	/* check for cheating */
	if ( YOURTURN!=FIRSTBID && cardret/13!=FIRSTSUIT )
		{
		for ( i=0; i<PIGCARDS; i++ )
			{
        		if ( PLAYERCARD[owner][i]/13==FIRSTSUIT )
				{
				sprintf(tmp,"You still have %s. Pick again...",
					SUITNAME[FIRSTSUIT] );
				draw_message( owner, tmp);
				return(54);
				}
			}
		}

	/* check for bidding the shown cards on first time */
	if ( YOURTURN==FIRSTBID ||
	     YOURTURN!=FIRSTBID && cardret/13==FIRSTSUIT )
	    {
	    /* find number of cards with the same suit as bidded */
	    nbidsuit = 0;
	    for ( i=0; i<PIGCARDS; i++ )
		{
		if ( PLAYERCARD[owner][i]/13==cardret/13 ) nbidsuit ++;
		}

	    for ( i=0; i<4; i++ )
		{
		if ( cardret==shcardata[i] && shcardowner[i]==owner )
		    {
		    if ( nbidsuit>1 && firstshowsuit[cardret/13]==0 )
			{
			draw_message( owner,
			    "You cannot pick it now. Pick again...");
			return(54);
			}
		    else
			break;
		    }
		}
	    }

        rank = PLAYERCARD[owner][pickcard]%13;
        suit = PLAYERCARD[owner][pickcard]/13;
	draw_table(rank, suit, owner);
        draw_pick_card( godpy[owner], gowind[owner], gogc[owner], owner,
		 PLAYERCARD[owner], PIGCARDS, pickcard );
	/* erase shown cards if picked */
	for ( i=0; i<4; i++ )
	    {
            if ( cardret==shcardata[i] && shcardowner[i]==owner )
		{
		shcardowner[i] = 4;
		for ( j=0; j<4; j++ ) draw_showcard(owner, j);
		}
	    }
	return(cardret);
}

shaffle_cards( cardold, cardnew )
int cardold[];
int cardnew[];
{
    int i, j, k, n, nshaff;
    double f, drand48();

    srand48( (long)time((time_t *)0) );
    f = drand48();
    n = f*15;
    if ( n>=5 )
        nshaff = n;
    else
        nshaff = 10;

    /* shaffle nshaff times */
    for ( k=1; k<nshaff; k++ )
	{
	for ( j=51; j>0; j-- )
            {
            /* generate a random number */
            f = drand48();
            n = f*j+.5;
            n = n%j;
            cardnew[j] = cardold[n];
            for ( i=n; i<j; i++ ) cardold[i] = cardold[i+1];
            }
        cardnew[0] = cardold[0];
	for ( j=0; j<26; j++ )
	    {
	    cardold[j*2]   = cardnew[j];
	    cardold[j*2+1] = cardnew[26+j];
	    }
	}

    /* shift first three cards */
    cardold[0] = cardnew[0];
    cardold[1] = cardnew[1];
    cardold[2] = cardnew[2];
    for ( j=0; j<49; j++ )
	cardnew[j] = cardnew[3+j];
    cardnew[49] = cardold[0];
    cardnew[50] = cardold[1];
    cardnew[51] = cardold[2];
}

reorder_cards( cards, ncards )
int cards[];
int ncards;
{
	int i, j, mid;

	for ( i=0; i<ncards-1; i++ )
		for ( j=i+1; j<ncards; j++ )
			{
			if ( cards[j] < cards[i] )
				{
				mid = cards[j];
				cards[j] = cards[i];
				cards[i] = mid;
				}
			}
}

draw_cards( dpyk, windk, gck, cards, pigk )
Display *dpyk;
Window	windk;
GC	gck;
int	cards[];
int	pigk;

{
	XClearWindow( dpyk, windk );
	draw_player(dpyk, windk, gck, pigk);
	draw_speaker(dpyk, windk, gck, pigk);
	draw_pick_card(dpyk, windk, gck, pigk, cards, 13, 100);
	XFlush( dpyk );
}

draw_player(dpyk, windk, gck, pigk)
Display *dpyk;
Window	windk;
GC	gck;
int	pigk;
{
    	table = windk;
	dpy   = dpyk;
	/* name and cards received of player at bottom */
	RGBColor(255, 0, 255, pigk, 0, 0);
	XDrawRectangle( dpyk, windk, gck, SRNW/2-40, SRNH/2+70,
		(int)(CARD_WIDTH*1.5), (int)(CARD_HEIGHT*0.5) );
	XFillRectangle( dpyk, windk, gck,
		SRNW/2-40+1, SRNH/2+70+1,
		(int)(CARD_WIDTH*1.5-2), (int)(CARD_HEIGHT*0.5-2) );

   	RGBColor(204, 55, 55, pigk, 1, 0);
	if ( strncmp( pnames[pigk], "PLAYER", 6 ) == 0 )
		{
        	XDrawString( dpyk, windk, gck,
			SRNW/2-20+1, SRNH/2+90+1,
               		pnames[pigk], strlen( pnames[pigk] ) );
	        XDrawString( dpyk, windk, gck,
			SRNW/2-20+1, SRNH/2+110+1,
       	        	"(yourself)", strlen("(yourself)") );
		}
	else
        	XDrawString( dpyk, windk, gck,
			SRNW/2-20+1, SRNH/2+100+1,
               		pnames[pigk], strlen( pnames[pigk] ) );

	/* name and cards received of player on the right */
	RGBColor(255, 0, 255, pigk, 0, 0);
	XDrawRectangle( dpyk, windk, gck,
		SRNW/2+140, SRNH/2-170,
		(int)(CARD_WIDTH*1.5), (int)(CARD_HEIGHT*0.5) );
	XFillRectangle( dpyk, windk, gck,
		SRNW/2+140+1, SRNH/2-170+1,
		(int)(CARD_WIDTH*1.5-2), (int)(CARD_HEIGHT*0.5-2) );
   	RGBColor(204, 55, 55, pigk, 1, 0);
        XDrawString( dpyk, windk, gck,
		SRNW/2+160+1, SRNH/2-140+1,
               	pnames[(pigk+1)%4], strlen( pnames[(pigk+1)%4] ) );

	/* name and cards received of player at top */
	RGBColor(255, 0, 255, pigk, 0, 0);
	XDrawRectangle( dpyk, windk, gck,
		SRNW/2-40, SRNH/2-375,
		(int)(CARD_WIDTH*1.5), (int)(CARD_HEIGHT*0.5) );
	XFillRectangle( dpyk, windk, gck,
		SRNW/2-40+1, SRNH/2-375+1,
		(int)(CARD_WIDTH*1.5-2), (int)(CARD_HEIGHT*0.5-2) );
   	RGBColor(204, 55, 55, pigk, 1, 0);
        XDrawString( dpyk, windk, gck,
		SRNW/2-20+1, SRNH/2-345+1,
               	pnames[(pigk+2)%4], strlen( pnames[(pigk+2)%4] ) );

	/* name and cards received of player on the left */
	RGBColor(255, 0, 255, pigk, 0, 0);
	XDrawRectangle( dpyk, windk, gck,
		SRNW/2-230, SRNH/2-170,
		(int)(CARD_WIDTH*1.5), (int)(CARD_HEIGHT*0.5) );
	XFillRectangle( dpyk, windk, gck,
		SRNW/2-230+1, SRNH/2-170+1,
		(int)(CARD_WIDTH*1.5-2), (int)(CARD_HEIGHT*0.5-2) );
   	RGBColor(204, 55, 55, pigk, 1, 0);
        XDrawString( dpyk, windk, gck,
		SRNW/2-210+1, SRNH/2-140+1,
               	pnames[(pigk+3)%4], strlen( pnames[(pigk+3)%4] ) );
}

draw_demerit(dpyk, windk, gck, pigk, claimer)
Display *dpyk;
Window	windk;
GC	gck;
int	pigk, claimer;
{
	int i, rank, suit, pigl, xoff;

    	table = windk;
	dpy   = dpyk;

	if ( pigk == claimer )
	    {
	    for ( i=0; i<demerit[pigk][16]; i++ )
		{
		rank = demerit[pigk][i]%13;
		suit = demerit[pigk][i]/13;
		paint_card( SRNW/2+i*CARD_WIDTH/4+40, SRNH-CARD_HEIGHT-170,
			rank, suit, 0, pigk );
		}
	    }

	pigl = (pigk+1) % 4;
	if ( pigl == claimer )
	    {
	    for ( i=0; i<demerit[pigl][16]; i++ )
		{
		rank = demerit[pigl][i]%13;
		suit = demerit[pigl][i]/13;
		paint_card( SRNW/2+i*CARD_WIDTH/4+190, SRNH-CARD_HEIGHT-410,
			rank, suit, 0, pigk );
		}
	    }

	pigl = (pigk+2) % 4;
	if ( pigl == claimer )
	    {
	    for ( i=0; i<demerit[pigl][16]; i++ )
		{
		rank = demerit[pigl][i]%13;
		suit = demerit[pigl][i]/13;
		paint_card( SRNW/2+i*CARD_WIDTH/4+85, 5,
			rank, suit, 0, pigk );
		}
	    }

	pigl = (pigk+3) % 4;
	if ( pigl == claimer )
	    {
	    xoff = 16 - demerit[pigl][16];
	    for ( i=0; i<demerit[pigl][16]; i++ )
		{
		rank = demerit[pigl][i]%13;
		suit = demerit[pigl][i]/13;
		paint_card( 10+(xoff+i)*CARD_WIDTH/4, SRNH-CARD_HEIGHT-410,
			rank, suit, 0, pigk );
		}
	    }
	XFlush(dpy);
}

draw_multimessage(message1, message2, pigk, redraw_flag)
char	message1[];
char	message2[];
int	pigk, redraw_flag;

{
	int i;
	for ( i=0; i<ndpy; i++ )
		{
	    	if ( redraw_flag>=0 && redraw_flag<4 && i!=redraw_flag )
	 	    continue;
		if ( i==pigk )
			{
			RGBColor(255, 0, 255, i, 0, 0);
		        XClearArea( godpy[i], gowind[i], 0, 0, 180, 90, False);
			draw_message( i, message1);
			RGBColor(0, 127, 255, i, 0, 0);
			XCopyPlane(godpy[i], goaheadPixmap[i], gowind[i],
				gogc[i], 0, 0, 80, 80, 10, 5, 1);
			if (BELLINT > 0 && BELLINT < 101) XBell(godpy[i], BELLINT);
			}
		else
			{
			RGBColor(255, 0, 255, i, 0, 0);
		        XClearArea( godpy[i], gowind[i], 0, 0, 180, 90, False);
			draw_message( i, message2);
			RGBColor(255, 0, 0, i, 0, 0);
			XCopyPlane(godpy[i], stopPixmap[i], gowind[i], gogc[i],
				0, 0, 80, 80, 95, 5, 1);
			}
		XFlush(godpy[i]);
		}
}

draw_message(pigk, message)
char	message[];

{
	XClearArea( godpy[pigk], gowind[pigk], 60, 90, 300, 100, False);
   	RGBColor(204, 55, 55, pigk, 0, 0);
        XDrawImageString( godpy[pigk], gowind[pigk], gogc[pigk], 70, 110,
		message, strlen(message) );
	XFlush( godpy[pigk] );
}

clear_table(dpyk, windk)
Display *dpyk;
Window	windk;

{
	XClearArea( dpyk, windk,
		SRNW/2-25, SRNH/2-60, CARD_WIDTH+2, CARD_HEIGHT+2, False);
	XClearArea( dpyk, windk,
		SRNW/2+55, SRNH/2-185, CARD_WIDTH+2, CARD_HEIGHT+2, False);
	XClearArea( dpyk, windk,
		SRNW/2-25, SRNH/2-310, CARD_WIDTH+2, CARD_HEIGHT+2, False);
	XClearArea( dpyk, windk,
		SRNW/2-105, SRNH/2-185, CARD_WIDTH+2, CARD_HEIGHT+2, False);
	XFlush( dpyk );
}

draw_pick_card(dpyk, windk, gck, pigk, cards, ncards, pickcard)
Display *dpyk;
Window	windk;
GC	gck;
int	cards[];
int	pigk, ncards, pickcard;
{
	int i, rank, suit;

    	table = windk;
	dpy   = dpyk;

	if ( ncards>13 ) ncards = 13;
	/* draw a name above the cards and whole card pile */
	if ( pickcard<0 || pickcard>=ncards )
		{
   		RGBColor( 204, 55, 55, pigk, 0, 0);
	        XDrawImageString( dpyk, windk, gck,
			250, SRNH-CARD_HEIGHT-50,
			"Your cards in hand", strlen("Your cards in hand") );

		/* clear card base */
		XClearArea( dpyk, windk,
			0, SRNH-CARD_HEIGHT-4,
			13*CARD_WIDTH+4, CARD_HEIGHT+4, False);
		for ( i=0; i<ncards; i++ )
			{
			rank = cards[i]%13;
			suit = cards[i]/13;
			paint_card( i*CARD_WIDTH, SRNH-CARD_HEIGHT-2,
				rank, suit, 0, pigk );
			}
		}
	else
		{

		/* shift cards in hand */
		for ( i=pickcard+1; i<ncards; i++ )
			{
			rank = cards[i]%13;
			suit = cards[i]/13;
			paint_card( (i-1)*CARD_WIDTH, SRNH-CARD_HEIGHT-2,
				rank, suit, 0, pigk );
			cards[i-1] = cards[i];
			}
		/* clear cards at tail */
		XClearArea( dpyk, windk,
			(ncards-1)*CARD_WIDTH+2, SRNH-CARD_HEIGHT-4,
			CARD_WIDTH+4, CARD_HEIGHT+4, False);
		}
	XFlush(dpyk);
}

draw_table(rank, suit, owner )
int	rank, suit, owner;
{
	int i;
	for ( i=0; i<ndpy; i++ )
	    {
    	    table = gowind[i];
	    dpy   = godpy[i];

	    /* draw the picked card */
	    if ( i == owner )
		paint_card( SRNW/2-25, SRNH/2-60, rank, suit, 0, i);
	    else if ( i == (owner+1) % 4 )
		paint_card( SRNW/2-105, SRNH/2-185, rank, suit, 0, i);
	    else if ( i == (owner+2) % 4 )
		paint_card( SRNW/2-25, SRNH/2-310, rank, suit, 0, i);
	    else if ( i == (owner+3) % 4 )
		paint_card( SRNW/2+55, SRNH/2-185, rank, suit, 0, i);
	    XFlush(dpy);
	    }
}

firsturn()
{
	int i, j;
	for ( i=0; i<4; i++ )
		for ( j=0; j<13; j++ )
			if ( PLAYERCARD[i][j] == Clubthree ) return(i);
}

claim_demerit(cards)
int	cards[4][2];
{
	int i, rank, rank2, suit, cardi, ndem;

	/* decide who will claim (de)merits */
	YOURTURN = cards[0][0];
	rank = cards[0][1]%13;
	for ( i=1; i<4; i++ )
		{
		suit = cards[i][1]/13;
		rank2 = cards[i][1]%13;
		if ( suit == FIRSTSUIT && rank2>rank )
			{
			YOURTURN = cards[i][0];
			rank = rank2;
			}
		}

	/* assign (de)merit array */
	ndem = demerit[YOURTURN][16];
	for ( i=0; i<4; i++ )
		{
		cardi = cards[i][1];
		if ( cardi>=13 && cardi<=25 ||
		     cardi==Qpig || cardi==Trans || cardi==Jsheep )
			{
			demerit[YOURTURN][ndem] = cardi;
			ndem ++;
			}
		}
	if ( demerit[YOURTURN][16] < ndem )
		{
		/* reorder (de)merit array and draw (de)merits */
		demerit[YOURTURN][16] = ndem;
		reorder_cards( demerit[YOURTURN], ndem );
       		for ( i=0; i<4; i++ )
                    draw_demerit(godpy[i], gowind[i], gogc[i], i, YOURTURN);
		}
	sleep(2);

	/* clear table */
        for ( i=0; i<4; i++ ) clear_table(godpy[i], gowind[i]);

	/* stack the discarded cards in CARDSEQ */
        for ( i=0; i<4; i++ ) CARDSEQ[4*(13-PIGCARDS)+i] = cards[i][1];

	/* set parameters */
	FIRSTBID = YOURTURN;
}

count_score()
{
	int i, j, doubler, cardj, ndem, nhearts;

	/* count scores and find last pig person */
	LASTPIG = 4;
	for ( i=0; i<4; i++ )
		{
		ndem = demerit[i][16];
		score[i] = 0;
		if ( ndem == 16 )
			{
			score[(i+1)%4] = -1000;
			if ( PAIR != 1 ) score[(i+2)%4] = -1000;
			score[(i+3)%4] = -1000;
			TOTSCORES[(i+1)%4] = -1000;
			if ( PAIR != 1 ) TOTSCORES[(i+2)%4] = -1000;
			TOTSCORES[(i+3)%4] = -1000;
			break;
			}
		else if ( ndem == 1 && demerit[i][0] == Qpig )
			{
			/* single pig (-100) */
			score[i] -= 100;
			if ( shcardrecord[0]<4 ) score[i] -= 100;
			LASTPIG = i;
			}
		else if ( ndem == 13 && demerit[i][0] >= 13 &&
				demerit[i][12] <= 25 )
			{
			/* all hearts including 2, 3, and 4 (+200) */
			score[i] += 200;
			if ( shcardrecord[1]<4 ) score[i] += 200;
			}
		else if ( ndem == 1 && demerit[i][0] == Trans )
			{
			/* single transformer (+50) */
			score[i] += 50;
			if ( shcardrecord[2]<4 ) score[i] += 50;
			}
		else if ( ndem == 1 && demerit[i][0] == Jsheep )
			{
			/* single sheep (+100) */
			score[i] += 100;
			if ( shcardrecord[3]<4 ) score[i] += 100;
			}
		else
			{
			doubler = 1;
			nhearts = 0;
			for ( j=0; j<ndem; j++ )
				{
				cardj = demerit[i][j];
				if ( cardj>=13 && cardj<=25 ) /* heart card */
					{
					score[i] += cardscore[cardj%13];
					if ( shcardrecord[1]<4 )
						score[i] += cardscore[cardj%13];
					nhearts++;
					}
		     		else if ( cardj==Qpig )
					{
					score[i] -= 100;
					if ( shcardrecord[0]<4 ) score[i]-=100;
					LASTPIG = i;
					}
				else if ( cardj==Trans )
					{
					doubler = 2;
					if ( shcardrecord[2]<4 ) doubler = 4;
					}
				else if ( cardj==Jsheep )
					{
					score[i] += 100;
					if ( shcardrecord[3]<4 ) score[i]+=100;
					}
				}
			if ( nhearts==13 )
				{
				score[i] += 400;
				if ( shcardrecord[1]<4 ) score[i] += 400;
				}
			score[i] *= doubler;
			}
		TOTSCORES[i] += score[i];
		}

	if ( PAIR == 1 )
		{
		TOTSCORES[0] += score[2];
		TOTSCORES[1] += score[3];
		TOTSCORES[2] = TOTSCORES[0];
		TOTSCORES[3] = TOTSCORES[1];
		}

	for ( i=0; i<4; i++ )
		if ( TOTSCORES[i]<=-1000 )
			{
			PIGGAME ++;
			PIGROUND = 0;
			LASTPIG = 1000;
			}
	/* message about scores */
	draw_score(1, -1);
	sleep(10);
}

draw_score( g_r_score, redraw_flag)
int	g_r_score, redraw_flag;

{
	char tmp[120];
	int i, j;

	/* draw the score */
	for ( i=0; i<ndpy; i++ )
	    {
	    if ( redraw_flag>=0 && redraw_flag<4 && i!=redraw_flag )
	 	continue;
	    XClearArea( godpy[i], gowind[i], 60, 90, 280, 90, False);
	    RGBColor(204, 55, 55, i, 0, 0);

	    if ( g_r_score == 1 )
       	        XDrawImageString( godpy[i], gowind[i], gogc[i], 70, 110,
			       "   name      round score      game score",
			strlen("   name      round score      game score"));
	    else
       	        XDrawImageString( godpy[i], gowind[i], gogc[i], 70, 110,
			       "   name      game score",
			strlen("   name      game score"));

	    for ( j=0; j<ndpy; j++ )
		{
	        if ( g_r_score == 1 )
		    sprintf(tmp,   "%s              %d                 %d\0",
			 pnames[j], score[j], TOTSCORES[j]);
		else
		    sprintf(tmp,   "%s              %d\0",
			 pnames[j], TOTSCORES[j]);

       		XDrawImageString( godpy[i], gowind[i], gogc[i], 70, 130+20*j,
			tmp, strlen(tmp));
		if ( TOTSCORES[j]<=-1000 )
			{
			sprintf(tmp,"%s is our honourable pig. Cheers!!!\0",
				 pnames[j] );
       			XDrawImageString( godpy[i], gowind[i], gogc[i],
				340, 130+20*j, tmp, strlen(tmp));
			}

		}
	    XFlush( godpy[i] );
	    }
}

redraw_table(exev, dpyk, windk, gck, pigk)
XExposeEvent	*exev;
Display		*dpyk;
Window		windk;
GC		gck;
int		pigk;
{
	int out, i, owner, rank, suit;
	char tmp[120];

        if ( exev->count == 0 )
		{
		if ( PIGCARDS>0 )
		    {
		    out = 0;
		    if ( PIGCARDS==13 && FIRSTBID==YOURTURN ) out = 1;

		    /* draw players */
		    draw_player(dpyk, windk, gck, pigk);

		    /* draw cards in hands, on the table, and demerits */
		    if ( PIGCARDS<14 )
		      {
                      sprintf(tmp,"Waiting for %s...\0", pnames[YOURTURN]);
                      draw_multimessage("Your turn now...\0",
                          tmp, YOURTURN, pigk);
		      for ( i=0; i<4; i++ )
			{
			owner = (FIRSTBID+i)%4;
			if ( owner==YOURTURN ) out = 1;
		    	if ( out==0 )
			    {
			    rank = FOURCARDS[i][1]%13;
			    suit = FOURCARDS[i][1]/13;
			    draw_table(rank, suit, owner);
			    }
			if ( owner==pigk && PIGCARDS-1+out>0 )
				{
		    		draw_pick_card(dpyk, windk, gck, pigk,
			    	PLAYERCARD[pigk], PIGCARDS-1+out, 100);
				}
		    	draw_demerit(dpyk, windk, gck, pigk, i);
			}
		      }
		    else
		      {
                      sprintf(tmp, "Waiting for %s to show the cards...\0",
                          pnames[YOURTURN]);
                      draw_multimessage("Your turn to show the cards...\0",
                          tmp, YOURTURN, pigk);
		      draw_pick_card(dpyk, windk, gck, pigk,
			   PLAYERCARD[pigk], 13, 100);
		      }
		    }
		else
		    /* draw the starting screen if at the beginning */
		    start_screen(pigk);
		}
}

show_cards(pigk)
int pigk;
{
        XSetWindowAttributes    windAttributes;
        unsigned        long    windMask;
        XEvent          eventPass;
	int xs, ys, flag, i;

	/* print the message enclosed by a rectangle */
	xs = 800;
	ys = 450;
	showcard_mes(pigk, xs, ys);
	/* open a window with a boundary and containing word "PASS" */

        XMapWindow(godpy[pigk], windPass[pigk]);

	gcRGBColor(gcPass[pigk], 255, 255, 50, pigk, 0, 0);
	XDrawString( godpy[pigk], windPass[pigk], gcPass[pigk], 70, 15,
		     "PASS", strlen("PASS") );
        XFlush( godpy[pigk] );
}

pick_showcard(x, y, owner)
int x, y, owner;
{
	int pickcard, i;

	if ( x>=0 && x<=PIGCARDS*CARD_WIDTH &&
	     y>=SRNH-CARD_HEIGHT && y<=SRNH )
		{
		for ( i=0; i<PIGCARDS; i++ )
		    if ( x>=CARDX[i] && x<CARDX[i+1] )
			{
			pickcard = PLAYERCARD[owner][i];
			break;
			}

		if ( pickcard==Qpig  || pickcard==Hace ||
		     pickcard==Trans || pickcard==Jsheep )
			{
			if ( pickcard==Qpig )
			    {
			    if ( shcardowner[0]==4 ) shcardowner[0] = owner;
			    else		     shcardowner[0] = 4;
			    }
			if ( pickcard==Hace )
			    {
			    if ( shcardowner[1]==4 ) shcardowner[1] = owner;
			    else		     shcardowner[1] = 4;
			    }
			if ( pickcard==Trans )
			    {
			    if ( shcardowner[2]==4 ) shcardowner[2] = owner;
			    else		     shcardowner[2] = 4;
			    }
			if ( pickcard==Jsheep )
			    {
			    if ( shcardowner[3]==4 ) shcardowner[3] = owner;
			    else		     shcardowner[3] = 4;
			    }
			draw_showcard(owner, owner);
			}
		else
			draw_message( owner,
				"You cannot show this card. Pick again...\0");
		}
	else
		draw_message( owner, "Please show a card or pass...\0");
}

init_showcard()
{
        int i, j, rank, suit;

	for ( i=0; i<4; i++ )
	    {
            dpy   = godpy[i];
	    for ( j=0; j<4; j++ )
		{
		shcard[i][j] = XCreatePixmap(godpy[i],
				RootWindow(godpy[i], gosrn[i]),
				40, 55, theDepth[i]);
        	table = shcard[i][j];
		rank = shcardata[j]%13;
		suit = shcardata[j]/13;
		paint_card(0, 0, rank, suit, 0, i);
		}
	    }
}

draw_showcard(owner, pigk)
int owner, pigk;
{
        int i, j, rank, suit;

	for ( j=0; j<4; j++ )
	  {
	  if ( shcardowner[j]<4 && shcardowner[j]==owner )
	    {
	    if ( pigk==owner )
		XCopyArea(godpy[pigk],shcard[pigk][j],gowind[pigk],gogc[pigk],
			0, 0, 40, 55, j*40+SRNW/2-200, SRNH/2+93);
	    else if ( (pigk+1)%4==owner )
		XCopyArea(godpy[pigk],shcard[pigk][j],gowind[pigk],gogc[pigk],
			0, 0, 40, 55, j*40+SRNW/2+180, SRNH/2-225);
	    else if ( (pigk+2)%4==owner )
		XCopyArea(godpy[pigk],shcard[pigk][j],gowind[pigk],gogc[pigk],
			0, 0, 40, 55, j*40+SRNW/2-200, SRNH/2-398);
	    else if ( (pigk+3)%4==owner )
		XCopyArea(godpy[pigk],shcard[pigk][j],gowind[pigk],gogc[pigk],
			0, 0, 40, 55, j*40+SRNW/2-310, SRNH/2-225);
	    }
	  else if ( shcardowner[j]==4 )
	    {
	    if ( pigk==owner )
		XClearArea(godpy[pigk], gowind[pigk],
			j*40+SRNW/2-200, SRNH/2+93, 40, 55, False);
	    else if ( (pigk+1)%4==owner )
		XClearArea(godpy[pigk], gowind[pigk],
			j*40+SRNW/2+180, SRNH/2-225, 40, 55, False);
	    else if ( (pigk+2)%4==owner )
		XClearArea(godpy[pigk], gowind[pigk],
			j*40+SRNW/2-200, SRNH/2-398, 40, 55, False);
	    else if ( (pigk+3)%4==owner )
		XClearArea(godpy[pigk], gowind[pigk],
			j*40+SRNW/2-310, SRNH/2-225, 40, 55, False);
	    }
	  }
	XFlush(godpy[pigk]);
}

showcard_mes(pigk, xs, ys)
int pigk, xs, ys;
{
        RGBColor(50, 50, 50, pigk, 0, 0);
        XDrawString( godpy[pigk], gowind[pigk], gogc[pigk], xs, ys,
                        "By showing the cards, you can",
                 strlen("By showing the cards, you can") );
        XDrawString( godpy[pigk], gowind[pigk], gogc[pigk], xs, ys+20,
                        "double the scores of spade",
                 strlen("double the scores of spade") );
        XDrawString( godpy[pigk], gowind[pigk], gogc[pigk], xs, ys+40,
                        "Queen, diamond Jack, and",
                 strlen("Queen, diamond Jack, and") );
        XDrawString( godpy[pigk], gowind[pigk], gogc[pigk], xs, ys+60,
                        "all the hearts with heart Ace,",
                 strlen("all the hearts with heart Ace,") );
        XDrawString( godpy[pigk], gowind[pigk], gogc[pigk], xs, ys+80,
                        "or make club Ten a quadrupler.",
                 strlen("or make club Ten a quadrupler.") );
        XDrawString( godpy[pigk], gowind[pigk], gogc[pigk], xs, ys+110,
                        "Withdraw cards by clicking twice.",
                 strlen("Withdraw cards by clicking twice.") );
        XDrawRectangle( godpy[pigk], gowind[pigk], gogc[pigk],
                        xs-30, ys-30, 260, 210);
        XDrawRectangle( godpy[pigk], gowind[pigk], gogc[pigk],
		xs-6, ys+129, 209, 39);
	XFlush(godpy[pigk]);
}

redraw_showcard(exev, dpyk, windk, gck, pigk)
XExposeEvent	*exev;
Display		*dpyk;
Window		windk;
GC		gck;
int		pigk;
{
	int out, i, owner, rank, suit;
	char tmp[120];

        if ( exev->count == 0 )
		{
		if ( PIGCARDS==14 )
		    {
		    /* draw show card before pigk */
		    for ( i=0; i<4; i++ )
			{
			owner = (FIRSTBID+i)%4;
			if ( pigk!=YOURTURN && owner==YOURTURN ) break;
			draw_showcard(owner, pigk);
			if ( owner==YOURTURN ) break;
			}
		    }
		else
		    {
		    /* draw show card according to shcardowner[] */
		    for ( i=0; i<4; i++ )
			{
			owner = (FIRSTBID+i)%4;
			draw_showcard(owner, pigk);
			}
		    }
		}
}

bghighlit(windk, gck, pigk, mx, my, message, blkwht)
Window windk;
GC     gck;
int    pigk, mx, my, blkwht;
char   message[];
{
    XSetWindowAttributes    windAttr;

    if ( blkwht==0 ) /* change background to black */
	{
        windAttr.background_pixel  = theBlackPixel[pigk];
	XChangeWindowAttributes(godpy[pigk], windk, CWBackPixel, &windAttr);
	/* clear window and draw the message */
	XClearWindow(godpy[pigk], windk);
	gcRGBColor(gck, 255, 0, 255, pigk, 1, 0);
	XDrawString( godpy[pigk], windk, gck, mx, my, message, strlen(message));
	}
    else
	{
        windAttr.background_pixel  = theWhitePixel[pigk];
	XChangeWindowAttributes(godpy[pigk], windk, CWBackPixel, &windAttr);
	/* clear window and draw the message */
	XClearWindow(godpy[pigk], windk);
	gcRGBColor(gck, 255, 255, 50, pigk, 0, 0);
	XDrawString( godpy[pigk], windk, gck, mx, my, message, strlen(message));
	}
    XFlush(godpy[pigk]);
}

bdhighlit(windk, pigk, inout)
Window windk;
int pigk, inout;
{
    XSetWindowAttributes    windAttr;

    if ( inout==0 ) /* entering window */
	{
	RGBColor(255, 255, 50, pigk, 0, 0);
        windAttr.border_pixel  = theHardwareColor.pixel;
	XChangeWindowAttributes(godpy[pigk], windk, CWBorderPixel, &windAttr);
	}
    else
	{
	RGBColor(200, 200, 200, pigk, 1, 0);
        windAttr.border_pixel  = theHardwareColor.pixel;
	XChangeWindowAttributes(godpy[pigk], windk, CWBorderPixel, &windAttr);
	}
}

draw_talkframe(pigk)
{
    /* frame and window content */
    RGBColor(0, 0, 0, pigk, 0, 0);
    XDrawRectangle( godpy[pigk], gowind[pigk], gogc[pigk], 0, 199, 89, 29);
    if ( flagtalk[pigk]==0 )
	windcontent(windtalk[pigk], gctalk[pigk], pigk,
	    5, 14, "    TALK", 1);
    else
	windcontent(windtalk[pigk], gctalk[pigk], pigk,
	    5, 14, "QUIT TALKING", 1);
}

draw_scoreframe(pigk)
{
    RGBColor(0, 0, 0, pigk, 0, 0);
    XDrawRectangle( godpy[pigk], gowind[pigk], gogc[pigk], 106, 199, 49, 29);
    windcontent(windscore[pigk], gcscore[pigk], pigk, 5, 14, "SCORE", 1);
}

windcontent(windk, gck, pigk, mx, my, message, blkwht)
Window windk;
GC     gck;
int    pigk, mx, my, blkwht;
char   message[];
{
    XSetWindowAttributes    windAttr;

    if ( blkwht==0 ) /* change background to black */
	{
        windAttr.background_pixel  = theBlackPixel[pigk];
	XChangeWindowAttributes(godpy[pigk], windk, CWBackPixel, &windAttr);
	/* draw the message */
	gcRGBColor(gck, 255, 0, 255, pigk, 1, 0);
	XDrawString(godpy[pigk], windk, gck, mx, my, message, strlen(message));
	}
    else
	{
        windAttr.background_pixel  = theWhitePixel[pigk];
	XChangeWindowAttributes(godpy[pigk], windk, CWBackPixel, &windAttr);
	/* draw the message */
	gcRGBColor(gck, 255, 255, 50, pigk, 0, 0);
	XDrawString(godpy[pigk], windk, gck, mx, my, message, strlen(message));
	}
    XFlush(godpy[pigk]);
}

draw_textframe(pigk)
{
    int i, owner;

    /* outframes and fill in white color */
    RGBColor(0, 0, 0, pigk, 0, 0);
    XDrawRectangle( godpy[pigk], gowind[pigk], gogc[pigk],
	0, 240, wframe+13, hframe+13);
    /* inner frames */
    RGBColor(0, 0, 0, pigk, 0, 0);
    for ( i=0; i<4; i++ )
	{
	owner = (pigk+i)%4;
	XDrawRectangle( godpy[pigk], windtext[pigk], gctext[pigk],
	    15, 25+i*(hsubframe+25), wsubframe, hsubframe);
	/* names */
	XDrawString( godpy[pigk], windtext[pigk], gctext[pigk],
	    15, 20+i*(hsubframe+25), pnames[owner], strlen(pnames[owner]) );
	/* texts */
	}
}

restore_message(pigk)
int pigk;
{
    char tmp[120];

    if ( pigk==YOURTURN )
	{
	if ( PIGCARDS==14 )
	    sprintf(tmp, "Your turn to show the cards...\0");
	else
	    sprintf(tmp, "Your turn now...\0");
	}
    else
	{
	if ( PIGCARDS==14 )
	    sprintf(tmp, "Waiting for %s to show the cards...\0",
		pnames[YOURTURN]);
	else
	    sprintf(tmp,"Waiting for %s...\0", pnames[YOURTURN]);
	}
    draw_message(pigk, tmp);
}

draw_speaker(dpyk, windk, gck, pigk)
Display *dpyk;
Window	windk;
GC	gck;
int	pigk;
{
    if ( theDepth[pigk]>1 )
	{
	RGBColor(173, 230, 216, pigk, 0, 1);
	RGBColor(255, 0, 0, pigk, 0, 0);
	}
    else
	RGBColor(0, 127, 255, pigk, 0, 0);

    /* speaker of player on the right */
    XCopyPlane(dpyk, speakerPixmap[pigk], windk, gck, 0, 0, 25, 25,
	SRNW/2+140+CARD_WIDTH*5/3, SRNH/2-170+CARD_HEIGHT/6, 1);
    /* speaker of player on the top */
    XCopyPlane(dpyk, speakerPixmap[pigk], windk, gck, 0, 0, 25, 25,
	SRNW/2-40+CARD_WIDTH/3, SRNH/2-375-CARD_HEIGHT/3, 1);
    /* speaker of player on the left */
    XCopyPlane(dpyk, speakerPixmap[pigk], windk, gck, 0, 0, 25, 25,
	SRNW/2-230-CARD_WIDTH, SRNH/2-170+CARD_HEIGHT/6, 1);

    if ( theDepth[pigk]>1 )
	RGBColor(255, 255, 255, pigk, 1, 1);
}

draw_speaking(pigk)
int	pigk;
{
    int i, j, owner;

    for ( i=1; i<4; i++ )
	{
	owner = (pigk+i)%4;
	if ( flagtalk[owner]==0 )
	    {
	    if ( theDepth[owner]>1 )
		{
		gcRGBColor(goxorgc[owner], 173, 230, 216, owner, 0, 1);
		gcRGBColor(goxorgc[owner], 255, 0, 0, owner, 0, 0);
		}
	    else
		gcRGBColor(goxorgc[owner], 0, 127, 255, owner, 0, 0);

	    for ( j=0; j<1; j++ )
		{
		if ( i==3 ) /* speaker of player on right */
		    XCopyPlane( godpy[owner], speakingPixmap[owner],
			gowind[owner], goxorgc[owner], 0, 0, 25, 25,
			SRNW/2+140+CARD_WIDTH*2,
			SRNH/2-170+CARD_HEIGHT/6, 1);
		if ( i==2 ) /* speaker of player on top */
		    XCopyPlane( godpy[owner], speakingPixmap[owner],
			gowind[owner], goxorgc[owner], 0, 0, 25, 25,
			SRNW/2-40+CARD_WIDTH*2/3,
			SRNH/2-375-CARD_HEIGHT/3, 1);
		if ( i==1 ) /* speaker of player on left */
		    XCopyPlane( godpy[owner], speakingPixmap[owner],
			gowind[owner], goxorgc[owner], 0, 0, 25, 25,
			SRNW/2-230-CARD_WIDTH*2/3,
			SRNH/2-170+CARD_HEIGHT/6, 1);
		}

	    if ( theDepth[pigk]>1 )
		gcRGBColor(goxorgc[owner], 255, 255, 255, owner, 1, 1);
	    }
	}
}

