/*
 *      Pig
 *
 *      (c) Copyright 1990, Yanan Yin
 *
 *      See copyright.h for the terms of the copyright.
 *
 *      @(#)util.c       3.0     90/09/14
 *
 */
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include "ydefs.h"

extern Display	*godpy[ndpy];
extern int	gosrn[ndpy];

int		theDepth[ndpy];
unsigned long	theBlackPixel[ndpy];
unsigned long	theWhitePixel[ndpy];
Colormap	theColormap[ndpy];

initX( dpyname )
char	dpyname[ndpy][120];
{
  int i;
  Display *XOpenDisplay();

  for ( i=0; i<ndpy; i++ )
     {
     godpy[i] = XOpenDisplay( dpyname[i] );

     if ( godpy[i] == NULL )
         {
         fprintf( stderr,
	   "ERROR: Cannot establish a connection to the X Server %s\n",
           XDisplayName( dpyname[i] ) );
         exit( 1 );
         }

     gosrn[i] = DefaultScreen( godpy[i] );
     theDepth[i]    = DefaultDepth( godpy[i], gosrn[i] );
     theBlackPixel[i] = BlackPixel( godpy[i], gosrn[i] );
     theWhitePixel[i] = WhitePixel( godpy[i], gosrn[i] );
     theColormap[i]   = DefaultColormap( godpy[i], gosrn[i] );
     }
}

xorSetUp(dpyk, windk, xorgck, pigk)
Display	*dpyk;
Window	windk;
GC	*xorgck;
int	pigk;
{
	createGC(dpyk, windk, xorgck, pigk);
	XSetFunction(dpyk, *xorgck, GXxor);
	XFlush(dpyk);
}

xorShutDown( dpyk, xorgck )
Display	*dpyk;
GC	xorgck;
{
	XFreeGC( dpyk, xorgck );
}

XFontStruct * initFont( dpyk, gck, fontName )
Display *dpyk;
GC 	gck;
char	fontName[];
{
	XFontStruct	*fontStruct;

	fontStruct	= XLoadQueryFont( dpyk, fontName );

	if ( fontStruct != 0 )
		{
		XSetFont( dpyk, gck, fontStruct->fid );
		}

		return( fontStruct );
}

#define	FULL_CIRCLE	(360*64)
#define START_CIRCLE	0

drawLine( dpyk, windk, gck, x1, y1, x2, y2 )
Display	*dpyk;
Window	windk;
GC	gck;
int	x1, y1;
int	x2, y2;
{
	XDrawLine( dpyk, windk, gck, x1, y1, x2, y2 );
}

drawRectangle( dpyk, windk, gck, x, y, width, height )
Display	*dpyk;
Window	windk;
GC	gck;
int	x, y;
int	width, height;{
	XDrawRectangle( dpyk, windk, gck, x, y, width, height );
}

fillRectangle( dpyk, windk, gck, x, y, width, height )
Display	*dpyk;
Window	windk;
GC	gck;
int	x, y;
int	width, height;
{
	XFillRectangle( dpyk, windk, gck, x, y, width, height );
}

drawOval( dpyk, windk, gck, x, y, width, height )
Display	*dpyk;
Window	windk;
GC	gck;
int	x, y;
int	width, height;
{
	XDrawArc( dpyk, windk, gck, x, y, width, height,
		 START_CIRCLE, FULL_CIRCLE );
}

fillOval( dpyk, windk, gck, x, y, width, height )
Display	*dpyk;
Window	windk;
GC	gck;
int	x, y;
int	width, height;
{
	XFillArc( dpyk, windk, gck, x, y, width, height,
		START_CIRCLE, FULL_CIRCLE );
}

quitX(dpyk)
Display   *dpyk;
{
     XCloseDisplay( dpyk );
}

