/*
 *      Pig
 *
 *      (c) Copyright 1990, Yanan Yin
 *
 *      See copyright.h for the terms of the copyright.
 *
 *      @(#)windowx.c       3.0     90/09/14
 *
 */
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include "bitm/piglogo.bm"
#include "ydefs.h"

extern int		theDepth[ndpy];
extern unsigned long	theBlackPixel[ndpy];
extern unsigned long	theWhitePixel[ndpy];
extern Colormap         theColormap[ndpy];

extern XColor	theHardwareColor;
extern char	pnames[4][120];

#define		BORDER_WIDTH	2

Window openWindow( dpyk, srnk, x, y, width, height, iconicState, gck, pigk )

Display *dpyk;
int	srnk;
int	x, y;
int	width, height;
int	iconicState;
GC 	*gck;
int	pigk;

{
	XSetWindowAttributes	theWindowAttributes;
	XSizeHints		theSizeHints;
	unsigned	long	theWindowMask;
	Window			windk;
	Pixmap			piglogoPixmap;
	XWMHints		theWMHints;
	XClassHint		theClassHint;
	int			i, j;
	XColor			crgb;
	char			tmp[120];

	theWindowAttributes.border_pixel      = theBlackPixel[pigk];

	if ( XAllocNamedColor(dpyk,theColormap[pigk],"LightBlue",&crgb,&crgb) )
		theWindowAttributes.background_pixel  = crgb.pixel;
	else
		theWindowAttributes.background_pixel  = theWhitePixel[pigk];

	theWindowAttributes.override_redirect = False;

	theWindowMask = CWBackPixel    |
			 CWBorderPixel |
			 CWOverrideRedirect;

	windk = XCreateWindow( dpyk, RootWindow( dpyk, srnk ),
			x+5*pigk, y+2*pigk, width, height,
			BORDER_WIDTH, theDepth[pigk],
			InputOutput, CopyFromParent,
			theWindowMask, &theWindowAttributes );

	piglogoPixmap = XCreateBitmapFromData( dpyk, windk,
				piglogo_bits, piglogo_width, piglogo_height );

	if ( iconicState == 0 )
		{
		theWMHints.initial_state= NormalState;
		}
	else
		{
		theWMHints.initial_state= IconicState;
		}

	theWMHints.icon_pixmap	= piglogoPixmap;
	theWMHints.flags	= IconPixmapHint | StateHint;

	XSetWMHints( dpyk, windk, &theWMHints );

	sprintf(tmp, "pig-driving%d (%s)", pigk+1, pnames[pigk]);
	XStoreName ( dpyk, windk, tmp );
	XSetIconName ( dpyk, windk, tmp );

	theSizeHints.flags	= USPosition | USSize;
	theSizeHints.x		= x;
	theSizeHints.y		= y;
	theSizeHints.width	= width;
	theSizeHints.height	= height;

	XSetNormalHints( dpyk, windk, &theSizeHints );

	if ( createGC( dpyk, windk, gck, pigk) == 0 )
		{
		XDestroyWindow( dpyk, windk );
		return( (Window) 0 );
		}

	XMapWindow( dpyk, windk );

	XFlush( dpyk );

	gfx_init( dpyk, srnk, pigk );

	return( windk );
}

Window subWindow(dpyk, windk, x, y, width, height, subgc, pigk, seleMask,imap)
Display *dpyk;
Window	windk;
int	x, y;
int	width, height;
GC 	*subgc;
int	pigk;
unsigned long seleMask;
int	imap;
{
	XSetWindowAttributes	subwAtt;
	unsigned	long	subwMask;
	Window			subwind;
	int			i, j;
	char			tmp[120];

        RGBColor(200, 200, 200, pigk, 1, 0);
        subwAtt.border_pixel      = theHardwareColor.pixel;
	subwAtt.background_pixel  = theWhitePixel[pigk];
	subwMask = CWBackPixel | CWBorderPixel;

	subwind = XCreateWindow( dpyk, windk, x, y, width, height,
		4, theDepth[pigk], InputOutput, CopyFromParent,
		subwMask, &subwAtt);
        XSelectInput( dpyk, subwind, seleMask );

	if ( createGC( dpyk, subwind, subgc, pigk)==0 )
		printf("no gc created\n");
	if ( imap==0 ) XMapWindow( dpyk, subwind );

	XFlush( dpyk );
	return( subwind );
}

createGC(dpyk, windk, gck, pigk)
Display *dpyk;
Window	windk;
GC	*gck;
int	pigk;
{
	XGCValues	theGCValues;

	*gck = XCreateGC( dpyk, windk, (unsigned long) 0, &theGCValues );

	if ( *gck == 0 )
		return( 0 );
	else
		{
		XSetForeground( dpyk, *gck, theBlackPixel[pigk] );
		XSetBackground( dpyk, *gck, theWhitePixel[pigk] );
		return( 1 );
		}
}

